package Hashlocker::HLDataDumper;
use Baseobject;
use Data::Dumper;
use FileHandle;
use strict;
use Fcntl;
use Carp;

$Data::Dumper::Indent=1;


our @ISA =('Baseobject' );

sub new
{
  my $pkg=shift;
  my $self= bless (new Baseobject(@_),$pkg);
  return $self;
}

sub genread
{
  my $self=shift;
  my $dbname=shift;

  my $filehandle= new FileHandle();
  our $VAR1={};

  unless (open ($filehandle,$dbname))
  {
    warn ("Could not read file: $dbname, $!\n")  ;
    return $VAR1;
  }

  #eat entire file
  local $/=undef;
  my $dumpvar=<$filehandle>;

  # eval of dumpvar generates $VAR1;
  eval ($dumpvar);
  unless (defined($VAR1))
  {
    carp("Could not read existing database: $dbname, data corrupt?\n")  ;
    $VAR1={};
  }
  return $VAR1;
}

sub read
{
  my $self=shift;
  my $dbname=shift;
  my $func=shift;
  $dbname.='.DataDumper';

  my $VAR1 = $self->genread($dbname);

  return undef unless (defined ($VAR1));
  return $func->($VAR1,@_) ;
}

sub write
{
  my $self=shift;
  my $dbname=shift;
  my $func=shift;
  my $hl=shift;
  my $result;
  my $VAR1={};

  $dbname.='.DataDumper';

  my $filehandle= new FileHandle();

  if (-e $dbname)
  {
    $VAR1=$self->genread($dbname);
    warn "dbase empty" unless (defined ($VAR1))
  }
  $result= $func->($VAR1,@_) ;

  my $mask=umask;
  umask $hl->field('umask');


  sysopen ($filehandle,$dbname,O_WRONLY|O_CREAT|O_TRUNC,$hl->field('fileperm')) or do
  {
    umask $mask;
    $self->error("Could not open file for writing: $dbname, $!");
    return undef;
  };

  my $d= Data::Dumper->new ([$VAR1]);

  print $filehandle $d->Dump;
  close ($filehandle);

  umask $mask;

  $result;
}


# Local Variables:
# mode: perl
# mode: font-lock
# End:
