package Hashlocker::HLNDBM;
use Baseobject;
use NDBM_File;
use strict;
use Fcntl;

our @ISA =('Baseobject' );

sub new
{
  my $pkg=shift;
  my $self= bless (new Baseobject(@_),$pkg);

  return $self;
}

sub read
{
  my $self=shift;
  my $dbname=shift;
  my $func=shift;

  my $userhash;
  my $result;

  if (tie (%$userhash,'NDBM_File',$dbname,O_RDONLY, 0660))
  {
    $result = $func->($userhash,@_) unless $self->error();
    untie (%$userhash);
  }
  else
  {
    $self->error("Error opening NDBM file \"$dbname\": $!");
  }
  $result;
}

sub write
{
  my $self=shift;
  my $dbname=shift;
  my $func=shift;
  my $hl=shift;
  my $result;
  my $userhash;
  #note file permissions are combined with local umask
  # see (http://search.cpan.org/author/JHI/perl-5.8.0/pod/perlfunc.pod#umask)

  my $mask=umask;
  umask $hl->field('umask');

  if ( tie (%$userhash,'NDBM_File',$dbname,O_RDWR|O_CREAT
	    ,$hl->field('fileperm')))
  {
    $result = $func->($userhash,@_) ;
    untie (%$userhash);
  }
  else
  {
    $self->error("Error opening NDBM file: \"$dbname\": $!");
  }
  umask $mask;
  $result;
}


# Local Variables:
# mode: perl
# mode: font-lock
# End:
